//
//  XMLParser.m
//  TestApp
//
//  Created by mac on 29.01.13.
//  Copyright (c) 2013 mac. All rights reserved.
//

#import "XMLParser.h"

@implementation XMLParser{
    NSInteger count;
}

@synthesize ads;

-(id)init{
    if(self=[super init]){
        ads = [[NSMutableArray alloc] init];
        count = 0;
    };
    
    return self;
}
-(id)loadXMLFromURL:(NSString *)urlString{

	NSURL *url		= [NSURL URLWithString:urlString];
	NSData	*data   = [[NSData alloc] initWithContentsOfURL:url];
	parser			= [[NSXMLParser alloc] initWithData:data];
	parser.delegate = self;
	[parser parse];
	return self;
}

-(void) parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName attributes:(NSDictionary *)attributeDict{
    //begining of announcement
    if ([elementName isEqualToString:@"announcement"])
	{
		currentAd = [[Announcement alloc] init];
        count+=1;
	}
    //retrieves node attributes
    if([elementName isEqualToString:@"currency"] || [elementName isEqualToString:@"price"] || [elementName isEqualToString:@"image"])
	{
        attributes = attributeDict;
	}
}

- (void) parser:(NSXMLParser *)parser didEndElement:(NSString *)elementname namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName
{
	if ([elementname isEqualToString:@"name"])
	{
		currentAd.name = currentNodeContent;   
	}
	if ([elementname isEqualToString:@"shortText"])
	{
		currentAd.description = currentNodeContent;
	}
    if ([elementname isEqualToString:@"value"])
	{
		currentAd.price = currentNodeContent;
	}
    if([elementname isEqualToString:@"currency"])
    {
        currentAd.price = [currentAd.price stringByAppendingFormat:@" %@",currentNodeContent];
    }
    if([elementname isEqualToString:@"price"] && [[attributes objectForKey:@"free"] isEqualToString:@"true"])
    {
        currentAd.price = @"в дар";
    }
    if([elementname isEqualToString:@"image"]){
        if([[attributes objectForKey:@"name"] isEqualToString:@"middle"]){
            [currentAd.imageArray addObject:[attributes objectForKey:@"url"]];
        }
        if([[attributes objectForKey:@"name"] isEqualToString:@"prev"]){
            if(!currentAd.titleImage) currentAd.titleImage = [attributes objectForKey:@"url"];
        }
    }
    //the end of announcement
	if ([elementname isEqualToString:@"announcement"])
	{
        //saves ready announcement into array "ads"
		[ads addObject:currentAd];
		currentAd = nil;
		currentNodeContent = nil;
        attributes = nil;
	}
}

- (void) parser:(NSXMLParser *)parser foundCharacters:(NSString *)string
{
	currentNodeContent = (NSMutableString *) [string stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
}

@end
